/*********************************************************************
 Copyright (C) 2003  Imperial College London
 Multimedia Knowledge Management Group

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*********************************************************************/

/*
 * externalprog.c
 *
 * Stefan M Rueger
 * annotation by an external programme 
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <errno.h>
#include <ctype.h>
#include <sys/param.h>
#include <sys/stat.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "annotate.h"

extern int extargc, extnampos;
extern char **extargv, *extlabel;

int externalprog(FILE *fp, AImage im) {
  int pid;

  fflush(stdout);
  fflush(stderr);

  if(extnampos)
     extargv[extnampos] = pars.jpgname;

  pid=fork();
  if(pid==-1)
    fatal("can't fork");
  
  if(pid == 0) {
    execvp(extargv[0], extargv);
    fatal("cannot execute %s ...", extargv[0]);
  }
  waitpid(pid, NULL, 0);

  return 1;
}
